/*
 *  @version 	        @(#)JfcTm.java	1.9 98/05/22
 *
 * Copyright (c) 1997 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */

package suntest.javastar.map.jfc;

import suntest.javastar.lib.JSTextMapping;
import java.awt.Component;

/**	
 *  Text mapping for JFC Swing
 *
 *  @date created      Oct 31, 1997
 *  @author	        Mark Hefner
 *
 */

public class JfcTm implements JSTextMapping {

  public String computeText(Component c){
	if(c instanceof javax.swing.AbstractButton){
	  javax.swing.AbstractButton b =
	    (javax.swing.AbstractButton)c;
	  String text = b.getText();
	  if (text == null || text.length() == 0) {
      text = b.getToolTipText();
      if (text == null || text.length() == 0) {
        text = b.getActionCommand();
      }
    }
	  return text;
	}
	if(c instanceof javax.swing.JLabel){
	  return ((javax.swing.JLabel)c).getText();
	}	
	if(c instanceof javax.swing.JComponent){
	  return ((javax.swing.JComponent)c).getToolTipText();
	}	
	return null;
  }
}
