/*
 *  @version 	        @(#)ComboBoxLoc.java	1.3 98/07/30
 *
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */

package suntest.javastar.map.jfc.utils;

import suntest.javastar.lib.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.MouseEvent;
import suntest.javastar.map.jfc.JfcTm;

/*
 *
 * Non Component Locator for ComboBox in JFC Swing
 *
 */
public class ComboBoxLoc  {

  public JSNCLData findObject(Component c, AWTEvent e){
    if((c instanceof JComboBox) && (e instanceof MouseEvent)){
      return findObject((JComboBox)c,((MouseEvent)e).getPoint());
    }
    return null;
  }

  public static JSNCLData findObject(JComboBox combo, Point p){
    Object obj = combo.getSelectedItem();
    String name = Parser.cleanToString(obj);
//     if (obj != null) {
//       int idx = combo.getSelectedIndex();
//       if (idx >= 0) {
//         ListCellRenderer renderer = combo.getRenderer();
//         JList L = combo.getUI().getList();
//         Component comp = renderer.getListCellRendererComponent(L, obj, idx, L.isSelectedIndex(idx), L.hasFocus());
//         if (comp != null) {
//           obj = comp;
//           if (comp.getName() != null && comp.getName().length() > 0) {
//             name = comp.getName();
//           } else {
//             if (comp instanceof Label)
//               name = ((Label)comp).getText();
//             else if (comp instanceof Button)
//               name = ((Button)comp).getLabel();
//             else if (comp instanceof JComponent) {
//               JfcTm tm = new JfcTm();
//               name = tm.computeText(comp);
//             }
//           }
//         }
//       } else { // obj is not in th elist
//         obj = null;
//       }
//     }
    return new JSNCLData(name, p, obj);
  }

  public JSNCLData getNamedObjectData(Component c, String wname){
    if(c instanceof JComboBox){
      Parser P = new Parser(wname);
      if(P.Valid){
        return getNamedObjectData((JComboBox)c, P);
      } else {
        throw new BadRegularExpressionError(wname + " is not a valid format");
      }
    }
    return null;
  }

  public static JSNCLData getNamedObjectData(JComboBox combo, Parser P){
    String rname = P.Value;
    return null;
  }

}
