/*
 *  @version 	        @(#)ListLoc.java	1.8 98/07/30
 *
 * Copyright (c) 1997-1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */

package suntest.javastar.map.jfc.utils;

import suntest.javastar.lib.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.MouseEvent;

/*
 *
 * Non Component Locator for JList in JFC Swing
 *
 *  @date created      Oct 23, 1997
 *  @author	        Mark Hefner
 *
 */

public class ListLoc implements JSNonComponentLocator {

  public JSNCLData findObject(Component c, AWTEvent e){
    if((c instanceof JList) && (e instanceof MouseEvent)){
      Point p = ((MouseEvent)e).getPoint();
      JList L = (JList)c;
      return findObject(L,p);
    }
    return null;
  }

  public static JSNCLData findObject(JList L, Point p){
    int idx = L.locationToIndex(p);
    if(idx!=-1){
      return getListDat(L,idx);
    }
    return null;
  }

  public JSNCLData getNamedObjectData(Component c, String wname){
    if(c instanceof JList){
      JList L = (JList)c;
      Parser P = new Parser(wname);
      if(P.Valid){
	return getNamedObjectData(L,P);
      } else {
	throw new BadRegularExpressionError(wname + " is not a valid format");
      }
    }
    return null;
  }

  public static JSNCLData getNamedObjectData(JList L, Parser P){
    int idx = P.Index;
    String rname = P.Value;
    ListModel M = L.getModel();
    int ct = M.getSize();
    if(idx>-1){
      if(idx<ct){
	if(rname!=null){
	  String name = Parser.cleanToString(M.getElementAt(idx));
	  if(!rname.equals(name)){
	    return null;
	  }
	}
	return getListDat(L,idx);
      }
    } else {
      for(int i=0;i<ct;i++){
	String name = Parser.cleanToString(M.getElementAt(i));
	if(name.equals(rname)){
	  return getListDat(L,i);
	}
      }
    }
    return null;
  }

  public static JSNCLData getListDat(JList L, int idx){
    ListModel M = L.getModel();
    if(idx>=M.getSize())return null;
    Point ul = L.indexToLocation(idx);
    Object o = M.getElementAt(idx);
    return new JSNCLData(idx+":"+Parser.cleanToString(o), ul, o);
  }

}
