/*
 *  @version 	        @(#)Parser.java	1.1 98/07/30
 *
 * Copyright (c) 1997-1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */

package suntest.javastar.map.jfc.utils;

/**	
 *  Parser for id in non-component locator
 *
 *  @date created      Oct 31, 1997
 *  @author	        Mark Hefner
 *
 */

public class Parser {

  public boolean Valid = false;
  public int Index = -1;
  public String Value = null;

  /** accepts one of three formats:
   * i:value
   * !i
   * ?value
   * (where i is a valid integer, value is any (possibly empty) string.
   */
  public Parser(String val){
    if(val!=null){
      if(val.length()>0){
	char fir = val.charAt(0);
	if(fir=='!'){
	  try{
	    Index = Integer.parseInt(val.substring(1));
	    Valid = true;
	  } catch(Exception e){
	  }
	} else if(fir=='?'){
	  Value = val.substring(1);
	  Valid = true;
	} else {
	  int ci = val.indexOf(':');
	  if(ci>0){
	    try{
	      Index = Integer.parseInt(val.substring(0,ci));
	      Value = val.substring(ci+1);
	      Valid = true;
	    } catch(Exception t){
	    }
	  }
	}
      }
    }
  }


  public static String cleanToString(Object o){
    if(o==null)return "null";
    String s = o.toString();
    if(s==null)return "null";
    int i = s.indexOf('@');
    int sl = s.length();
    while(i>-1){
      int j = i+1;
      while((j<sl)&&(vh(s.charAt(j))))j++;
      s = s.substring(0,i+1)+"xxxxxx"+s.substring(j);
      i = s.indexOf('@',i+1);
    }
    return s;
  }

  private static boolean vh(char c){
    if((c>='0')&&(c<='9'))return true;
    if((c>='a')&&(c<='f'))return true;
    if((c>='A')&&(c<='F'))return true;
    return false;
  }

}
