/*
 *  @version 	        @(#)TableHeadLoc.java	1.7 98/07/30
 *
 * Copyright (c) 1997-1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */

package suntest.javastar.map.jfc.utils;

import suntest.javastar.lib.*;
import javax.swing.table.*;
import java.awt.Point;

/**	
 *  Non Component Locator for Table Header
 *
 *  @date created      Dec 8, 1997
 *  @author	       Mark Hefner
 *
 */

public class TableHeadLoc {

  public static JSNCLData findObject(JTableHeader H, Point p){
    int idx = H.columnAtPoint(p);
    if(idx<0)return null;
    TableColumnModel mod = H.getColumnModel();
    TableColumn col = mod.getColumn(idx);
    int ledge = findLeftEdge(mod,p.x,idx);
    Object o = col.getHeaderValue();
    String s = Parser.cleanToString(o);
    String name = idx+":"+s;
    return new JSNCLData(name,new Point(ledge,0),o);
  }

  public static JSNCLData getNamedObjectData(JTableHeader H, Parser P){
    int idx = P.Index;
    String rname = P.Value;
    TableColumnModel M = H.getColumnModel();
    int ct = M.getColumnCount();
    //System.err.println(idx+"-"+rname+"-"+ct);
    if(idx>-1){
      if(idx<ct){
	Object o = M.getColumn(idx).getHeaderValue();
	String name = Parser.cleanToString(o);
	if(rname!=null){
	  if(!rname.equals(name)){
	    return null;
	  }
	}
	int ledge = findLeftEdgeThinAir(M,idx,H.getSize().width);
	return new JSNCLData(idx+":"+name,new Point(ledge,0),o);
      }
    } else {
      for(int i=0;i<ct;i++){
	try{
	  Object o = M.getColumn(i).getHeaderValue();
	  String name = Parser.cleanToString(o);
	  //System.err.println(name+"=?="+rname);
	  if(name.equals(rname)){
	    int ledge = findLeftEdgeThinAir(M,i,H.getSize().width);
	    return new JSNCLData(i+":"+name,new Point(ledge,0),o);
	  }
	} catch(Exception e){
	  e.printStackTrace();
	}
      }
    }
    return null;
  }

  private static int findLeftEdge(TableColumnModel mod, int orig, int val){
    int min = orig;
    int chk = min-5;
    while(mod.getColumnIndexAtX(chk)==val){
      min = chk;
      chk = min-5;
    }
    chk = min-1;
    while(mod.getColumnIndexAtX(chk)==val){
      min = chk;
      chk = min-1;
    }
    return min;
  }

  private static int findLeftEdgeThinAir(TableColumnModel mod, int val, int max){
    for(int i=0;i<max;i+=5){
      if(mod.getColumnIndexAtX(i)==val){
	return findLeftEdge(mod,i,val);
      }
    }
    return 0;
  }

}
