/*
 *  @version 	        @(#)TableLoc.java	1.5 98/05/15
 *
 * Copyright (c) 1997-1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */

package suntest.javastar.map.jfc.utils;

import suntest.javastar.lib.*;
import javax.swing.*;
import java.awt.*;

/**	
 *  Non Component Locator for JTable
 *
 *  @date created      Oct 31, 1997
 *  @author	        Mark Hefner
 *
 */

public class TableLoc {

  public static JSNCLData findObject(JTable t, Point p){
    int c = t.columnAtPoint(p);
    int r = t.rowAtPoint(p);
    if((r>-1)&&(c>-1)){
      Rectangle re = t.getCellRect(c,r,false);
      return new JSNCLData(""+r+","+c,new Point(re.x,re.y),t.getValueAt(r,c));
    }
    return null;
  }

  public static JSNCLData getNamedObjectData(JTable t, String name){
    int ci = name.indexOf(',');
    if(ci>0){
      try{
	int r = Integer.parseInt(name.substring(0,ci));
	int c = Integer.parseInt(name.substring(1+ci));
	Rectangle re = t.getCellRect(c,r,false);
	return new JSNCLData(""+r+","+c,new Point(re.x,re.y),t.getValueAt(r,c));
      } catch(Exception e){
      }
    }
    return null;
  }

}
